Overview | Package | Class | Use | Tree | Deprecated | Index | Help
| JavaTM 2 Platform Standard Ed. 5.0
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## java.util.concurrent
Class CopyOnWriteArraySet<E>

    java.lang.Object
      java.util.AbstractCollection<E>
          java.util.AbstractSet<E>
              java.util.concurrent.CopyOnWriteArraySet<E>

Type Parameters:
  `E` - the type of elements held in this collection

All Implemented Interfaces:
  Serializable, Iterable<E>, Collection<E>, Set<E>

    public class CopyOnWriteArraySet<E>

extends AbstractSet<E>
implements Serializable

A `Set` that uses `CopyOnWriteArrayList` for all of its operations. Thus, it shares the same basic properties:

- It is best suited for applications in which set sizes generally stay small, read-only operations vastly outnumber mutative operations, and you need to prevent interference among threads during traversal.
- It is thread-safe.
- Mutative operations(add, set, remove, etc) are expensive since they usually entail copying the entire underlying array.
- Iterators do not support the mutative remove operation.
- Traversal via iterators is fast and cannot encounter interference from other threads. Iterators rely on unchanging snapshots of the array at the time the iterators were constructed.

Sample Usage. The following code sketch uses a copy-on-write set to maintain a set of Handler objects that perform some action upon state updates.

     class Handler { void handle(); ... }

     class X {
        private final CopyOnWriteArraySet<Handler> handlers = new CopyOnWriteArraySet<Handler>();
        public void addHandler(Handler h) { handlers.add(h); }

        private long internalState;
        private synchronized void changeState() { internalState = ...; }

        public void update() {
           changeState();
           for (Handler handler : handlers)
               handler.handle();
        }
     }

This class is a member of the Java Collections Framework.

Since:
  1.5
See Also:
  `CopyOnWriteArrayList`, Serialized Form

Constructor Summary
`CopyOnWriteArraySet()` Creates an empty set.
`CopyOnWriteArraySet(Collection<? extends E> c)` Creates a set containing all of the elements of the specified Collection.

Method Summary
`boolean` | `add(E o)` Ensures that this collection contains the specified element (optional operation).
`boolean` | `addAll(Collection<? extends E> c)` Adds all of the elements in the specified collection to this collection (optional operation).
`void` | `clear()` Removes all of the elements from this collection (optional operation).
`boolean` | `contains(Object o)` Returns `true` if this collection contains the specified element.
`boolean` | `containsAll(Collection<?> c)` Returns `true` if this collection contains all of the elements in the specified collection.
`boolean` | `isEmpty()` Returns `true` if this collection contains no elements.
`Iterator<E>` | `iterator()` Returns an iterator over the elements contained in this collection.
`boolean` | `remove(Object o)` Removes a single instance of the specified element from this collection, if it is present (optional operation).
`boolean` | `removeAll(Collection<?> c)` Removes from this set all of its elements that are contained in the specified collection (optional operation).
`boolean` | `retainAll(Collection<?> c)` Retains only the elements in this collection that are contained in the specified collection (optional operation).
`int` | `size()` Returns the number of elements in this collection.
`Object[]` | `toArray()` Returns an array containing all of the elements in this collection.
`
`<T> T[]`
` | `toArray(T[] a)` Returns an array containing all of the elements in this collection; the runtime type of the returned array is that of the specified array.

Methods inherited from class java.util.AbstractSet
`equals, hashCode`

Methods inherited from class java.util.AbstractCollection
`toString`

Methods inherited from class java.lang.Object
`clone, finalize, getClass, notify, notifyAll, wait, wait, wait`

Constructor Detail

### CopyOnWriteArraySet

    public CopyOnWriteArraySet()

  Creates an empty set.

### CopyOnWriteArraySet

    public CopyOnWriteArraySet(Collection<? extends E> c)

  Creates a set containing all of the elements of the specified Collection.

  Parameters:
    `c` - the collection

Method Detail

### size

    public int size()

  Description copied from class: `AbstractCollection`
  Returns the number of elements in this collection. If the collection contains more than `Integer.MAX_VALUE` elements, returns `Integer.MAX_VALUE`.

  Specified by:
    `size` in interface `Collection<E>`
  Specified by:
    `size` in interface `Set<E>`
  Specified by:
    `size` in class `AbstractCollection<E>`
  Returns:
    the number of elements in this collection.

### isEmpty

    public boolean isEmpty()

  Description copied from class: `AbstractCollection`
  Returns `true` if this collection contains no elements.

  This implementation returns `size() == 0`.

  Specified by:
    `isEmpty` in interface `Collection<E>`
  Specified by:
    `isEmpty` in interface `Set<E>`
  Overrides:
    `isEmpty` in class `AbstractCollection<E>`
  Returns:
    `true` if this collection contains no elements.

### contains

    public boolean contains(Object o)

  Description copied from class: `AbstractCollection`
  Returns `true` if this collection contains the specified element. More formally, returns `true` if and only if this collection contains at least one element `e` such that `(o==null ? e==null : o.equals(e))`.

  This implementation iterates over the elements in the collection, checking each element in turn for equality with the specified element.

  Specified by:
    `contains` in interface `Collection<E>`
  Specified by:
    `contains` in interface `Set<E>`
  Overrides:
    `contains` in class `AbstractCollection<E>`
  Parameters:
    `o` - object to be checked for containment in this collection.
  Returns:
    `true` if this collection contains the specified element.

### toArray

    public Object[] toArray()

  Description copied from class: `AbstractCollection`
  Returns an array containing all of the elements in this collection. If the collection makes any guarantees as to what order its elements are returned by its iterator, this method must return the elements in the same order. The returned array will be "safe" in that no references to it are maintained by the collection. (In other words, this method must allocate a new array even if the collection is backed by an Array). The caller is thus free to modify the returned array.

  This implementation allocates the array to be returned, and iterates over the elements in the collection, storing each object reference in the next consecutive element of the array, starting with element 0.

  Specified by:
    `toArray` in interface `Collection<E>`
  Specified by:
    `toArray` in interface `Set<E>`
  Overrides:
    `toArray` in class `AbstractCollection<E>`
  Returns:
    an array containing all of the elements in this collection.

### toArray

    public <T> T[] toArray(T[] a)

  Description copied from class: `AbstractCollection`
  Returns an array containing all of the elements in this collection; the runtime type of the returned array is that of the specified array. If the collection fits in the specified array, it is returned therein. Otherwise, a new array is allocated with the runtime type of the specified array and the size of this collection.

  If the collection fits in the specified array with room to spare (i.e., the array has more elements than the collection), the element in the array immediately following the end of the collection is set to `null`. This is useful in determining the length of the collection only if the caller knows that the collection does not contain any `null` elements.)

  If this collection makes any guarantees as to what order its elements are returned by its iterator, this method must return the elements in the same order.

  This implementation checks if the array is large enough to contain the collection; if not, it allocates a new array of the correct size and type (using reflection). Then, it iterates over the collection, storing each object reference in the next consecutive element of the array, starting with element 0. If the array is larger than the collection, a `null` is stored in the first location after the end of the collection.

  Specified by:
    `toArray` in interface `Collection<E>`
  Specified by:
    `toArray` in interface `Set<E>`
  Overrides:
    `toArray` in class `AbstractCollection<E>`
  Parameters:
    `a` - the array into which the elements of the collection are to be stored, if it is big enough; otherwise, a new array of the same runtime type is allocated for this purpose.
  Returns:
    an array containing the elements of the collection.

### clear

    public void clear()

  Description copied from class: `AbstractCollection`
  Removes all of the elements from this collection (optional operation). The collection will be empty after this call returns (unless it throws an exception).

  This implementation iterates over this collection, removing each element using the `Iterator.remove` operation. Most implementations will probably choose to override this method for efficiency.

  Note that this implementation will throw an `UnsupportedOperationException` if the iterator returned by this collection's `iterator` method does not implement the `remove` method and this collection is non-empty.

  Specified by:
    `clear` in interface `Collection<E>`
  Specified by:
    `clear` in interface `Set<E>`
  Overrides:
    `clear` in class `AbstractCollection<E>`

### iterator

    public Iterator<E> iterator()

  Description copied from class: `AbstractCollection`
  Returns an iterator over the elements contained in this collection.

  Specified by:
    `iterator` in interface `Iterable<E>`
  Specified by:
    `iterator` in interface `Collection<E>`
  Specified by:
    `iterator` in interface `Set<E>`
  Specified by:
    `iterator` in class `AbstractCollection<E>`
  Returns:
    an iterator over the elements contained in this collection.

### remove

    public boolean remove(Object o)

  Description copied from class: `AbstractCollection`
  Removes a single instance of the specified element from this collection, if it is present (optional operation). More formally, removes an element `e` such that `(o==null ? e==null : o.equals(e))`, if the collection contains one or more such elements. Returns `true` if the collection contained the specified element (or equivalently, if the collection changed as a result of the call).

  This implementation iterates over the collection looking for the specified element. If it finds the element, it removes the element from the collection using the iterator's remove method.

  Note that this implementation throws an `UnsupportedOperationException` if the iterator returned by this collection's iterator method does not implement the `remove` method and this collection contains the specified object.

  Specified by:
    `remove` in interface `Collection<E>`
  Specified by:
    `remove` in interface `Set<E>`
  Overrides:
    `remove` in class `AbstractCollection<E>`
  Parameters:
    `o` - element to be removed from this collection, if present.
  Returns:
    `true` if the collection contained the specified element.

### add

    public boolean add(E o)

  Description copied from class: `AbstractCollection`
  Ensures that this collection contains the specified element (optional operation). Returns `true` if the collection changed as a result of the call. (Returns `false` if this collection does not permit duplicates and already contains the specified element.) Collections that support this operation may place limitations on what elements may be added to the collection. In particular, some collections will refuse to add `null` elements, and others will impose restrictions on the type of elements that may be added. Collection classes should clearly specify in their documentation any restrictions on what elements may be added.

  This implementation always throws an `UnsupportedOperationException`.

  Specified by:
    `add` in interface `Collection<E>`
  Specified by:
    `add` in interface `Set<E>`
  Overrides:
    `add` in class `AbstractCollection<E>`
  Parameters:
    `o` - element whose presence in this collection is to be ensured.
  Returns:
    `true` if the collection changed as a result of the call.

### containsAll

    public boolean containsAll(Collection<?> c)

  Description copied from class: `AbstractCollection`
  Returns `true` if this collection contains all of the elements in the specified collection.

  This implementation iterates over the specified collection, checking each element returned by the iterator in turn to see if it's contained in this collection. If all elements are so contained `true` is returned, otherwise `false`.

  Specified by:
    `containsAll` in interface `Collection<E>`
  Specified by:
    `containsAll` in interface `Set<E>`
  Overrides:
    `containsAll` in class `AbstractCollection<E>`
  Parameters:
    `c` - collection to be checked for containment in this collection.
  Returns:
    `true` if this collection contains all of the elements in the specified collection.
  See Also:
    `AbstractCollection.contains(Object)`

### addAll

    public boolean addAll(Collection<? extends E> c)

  Description copied from class: `AbstractCollection`
  Adds all of the elements in the specified collection to this collection (optional operation). The behavior of this operation is undefined if the specified collection is modified while the operation is in progress. (This implies that the behavior of this call is undefined if the specified collection is this collection, and this collection is nonempty.)

  This implementation iterates over the specified collection, and adds each object returned by the iterator to this collection, in turn.

  Note that this implementation will throw an `UnsupportedOperationException` unless `add` is overridden (assuming the specified collection is non-empty).

  Specified by:
    `addAll` in interface `Collection<E>`
  Specified by:
    `addAll` in interface `Set<E>`
  Overrides:
    `addAll` in class `AbstractCollection<E>`
  Parameters:
    `c` - collection whose elements are to be added to this collection.
  Returns:
    `true` if this collection changed as a result of the call.
  See Also:
    `AbstractCollection.add(Object)`

### removeAll

    public boolean removeAll(Collection<?> c)

  Description copied from class: `AbstractSet`
  Removes from this set all of its elements that are contained in the specified collection (optional operation).

  This implementation determines which is the smaller of this set and the specified collection, by invoking the `size` method on each. If this set has fewer elements, then the implementation iterates over this set, checking each element returned by the iterator in turn to see if it is contained in the specified collection. If it is so contained, it is removed from this set with the iterator's `remove` method. If the specified collection has fewer elements, then the implementation iterates over the specified collection, removing from this set each element returned by the iterator, using this set's `remove` method.

  Note that this implementation will throw an `UnsupportedOperationException` if the iterator returned by the `iterator` method does not implement the `remove` method.

  Specified by:
    `removeAll` in interface `Collection<E>`
  Specified by:
    `removeAll` in interface `Set<E>`
  Overrides:
    `removeAll` in class `AbstractSet<E>`
  Parameters:
    `c` - elements to be removed from this set.
  Returns:
    `true` if this set changed as a result of the call.
  See Also:
    `AbstractCollection.remove(Object)`, `AbstractCollection.contains(Object)`

### retainAll

    public boolean retainAll(Collection<?> c)

  Description copied from class: `AbstractCollection`
  Retains only the elements in this collection that are contained in the specified collection (optional operation). In other words, removes from this collection all of its elements that are not contained in the specified collection.

  This implementation iterates over this collection, checking each element returned by the iterator in turn to see if it's contained in the specified collection. If it's not so contained, it's removed from this collection with the iterator's `remove` method.

  Note that this implementation will throw an `UnsupportedOperationException` if the iterator returned by the `iterator` method does not implement the `remove` method and this collection contains one or more elements not present in the specified collection.

  Specified by:
    `retainAll` in interface `Collection<E>`
  Specified by:
    `retainAll` in interface `Set<E>`
  Overrides:
    `retainAll` in class `AbstractCollection<E>`
  Parameters:
    `c` - elements to be retained in this collection.
  Returns:
    `true` if this collection changed as a result of the call.
  See Also:
    `AbstractCollection.remove(Object)`, `AbstractCollection.contains(Object)`

Overview | Package | Class | Use | Tree | Deprecated | Index | Help
| JavaTM 2 Platform Standard Ed. 5.0
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

Submit a bug or feature
For further API reference and developer documentation, see Java 2 SDK SE Developer Documentation. That documentation contains more detailed, developer-targeted descriptions, with conceptual overviews, definitions of terms, workarounds, and working code examples.

Copyright 2004 Sun Microsystems, Inc. All rights reserved. Use is subject to license terms. Also see the documentation redistribution policy.